#include "main.h"

void 
read_config_file(void)
{
    FILE *fp;
    char line[400], cmd[100], arg[100];
    int val;

    if( (fp = fopen(gs.configfile, "r")) == NULL ) {
      fprintf(stderr, "Couldn't open config file for reading: %s\n", gs.configfile);
      usage();
    }

    gs.logfp                    = stderr;
    gs.statslogfp               = NULL;

    gs.server_name[0]           = '\0';

    gs.listen_port              = -1;

    gs.player_name[0]           = '\0';
    gs.player_shirt             = 0;
    gs.player_pants             = 0;

    gs.kick_impulse             = -1;
    gs.ban_impulse              = -1;
    gs.init_impulse             = -1;
    gs.init01_impulse           = -1;
    gs.init02_impulse           = -1;
    gs.init03_impulse           = -1;
    gs.init04_impulse           = -1;
    gs.ban_white_guys           = -1;
    gs.allow_null_name          = TRUE;
    gs.allow_in_game_command    = TRUE;
    gs.password[0]              = '\0';
    gs.banfile[0]               = '\0';

    gs.banip_list               = NULL;
    gs.banname_list             = NULL;
    gs.bancolor_list            = NULL;
    gs.stuff_commands           = NULL;

    while( fgets(line, 400, fp) != NULL ) {

      cmd[0] = arg[0] = '\0';

      val = sscanf(line, "%s %s", cmd, arg);

      if( val <= 0  || cmd[0] == '#' ) {
        continue;
      }

      if( strcmp(cmd, "quakeserver") == 0 ) {
         strcpy(gs.server_name, arg);
      } else if( strcmp(cmd, "player_name") == 0 ) {
         if( arg ) {
           map_control_chars(gs.player_name, arg, MAX_NAMELEN);
         }
      } else if( strcmp(cmd, "shirt_color") == 0 ) {
         gs.player_shirt = atoi(arg);
      } else if( strcmp(cmd, "pants_color") == 0 ) {
         gs.player_pants = atoi(arg);
      } else if( strcmp(cmd, "listen_port") == 0 ) {
         gs.listen_port = atoi(arg);
      } else if( strcmp(cmd, "stats_file") == 0 ) {
         if( strlen(arg) == 0 || (gs.statslogfp = fopen(arg, "a")) == NULL ) {
           fprintf(stderr, "Unable to open stats_file: %s\n", arg);
           exit(1);
         }
      } else if( strcmp(cmd, "log_file") == 0 ) {
         if( strlen(arg) == 0 || (gs.logfp = fopen(arg, "a")) == NULL ) {
           fprintf(stderr, "Unable to open log_file: %s\n", arg);
           exit(1);
         }
      } else if( strcmp(cmd, "kick_impulse") == 0 ) {
         gs.kick_impulse = atoi(arg);
      } else if( strcmp(cmd, "ban_impulse") == 0 ) {
         gs.ban_impulse = atoi(arg);
      } else if( strcmp(cmd, "init_impulse") == 0 ) {
         gs.init_impulse = atoi(arg);
      } else if( strcmp(cmd, "init01_impulse") == 0 ) {
         gs.init01_impulse = atoi(arg);
      } else if( strcmp(cmd, "init02_impulse") == 0 ) {
         gs.init02_impulse = atoi(arg);
      } else if( strcmp(cmd, "init03_impulse") == 0 ) {
         gs.init03_impulse = atoi(arg);
      } else if( strcmp(cmd, "init04_impulse") == 0 ) {
         gs.init04_impulse = atoi(arg);
      } else if( strcmp(cmd, "ban_white_guys") == 0 ) {
         gs.ban_white_guys = atoi(arg);
      } else if( strcmp(cmd, "allow_null_name") == 0 ) {
         gs.allow_null_name = atoi(arg);
      } else if( strcmp(cmd, "allow_in_game_command") == 0 ) {
         gs.allow_in_game_command = atoi(arg);
      } else if( strcmp(cmd, "password") == 0 ) {
         strcpy(gs.password, arg);
      } else if( strcmp(cmd, "banfile") == 0 ) {
         strcpy(gs.banfile, arg);
      } else {
         fprintf(stderr, "Unknown command in config file: %s\n", cmd);
         exit(1);
      }

    }
    fclose(fp);

    if( strlen(gs.server_name) == 0 ) {
      fprintf(stderr, "'quakeserver' must be specified in config file\n");
      exit(1);
    }

    if( strchr(gs.server_name, ':') == NULL ) {
      fprintf(stderr, "Port missing from 'quakeserver' in config file\n");
      exit(1);
    }

    if( strlen(gs.banfile) == 0 ) {
      fprintf(stderr, "'banfile' must be specified in config file\n");
      exit(1);
    }

    if( gs.listen_port == -1 ) {
      gs.accepting_clients = FALSE;
    } else if( gs.listen_port == 0 || gs.listen_port > 65535 ) {
      fprintf(stderr, "Invalid value for 'listen_port': %d\n", gs.listen_port); 
      exit(1);
    } else {
      if( strlen(gs.password) == 0 ) {
        fprintf(stderr, "A password must be specified to enable frontend connections\n"); 
        exit(1);
      }
      gs.accepting_clients = TRUE;
    }

}
