/*
 *  timer.h
 *
 *  Header file for some timer routines.
 *
 *  Kekoa Proudfoot
 *  12/12/96
 */

#ifndef TIMER_H_DEFINED
#define TIMER_H_DEFINED

#ifdef WIN32
#include <windows.h>
#else
#include <sys/time.h>
#endif

typedef struct qtimer_t {
    int     running;
    double  start_time;
    double  elapsed_time;
} qtimer_t;

extern double reset_timer   (qtimer_t *timer);
extern double start_timer   (qtimer_t *timer);
extern double stop_timer    (qtimer_t *timer);
extern double read_timer    (qtimer_t *timer);
extern double restart_timer (qtimer_t *timer);

#ifdef WIN32
extern int   gettimeofday  (struct timeval *tp, void *tzp);
#endif

#endif
